#include <iostream>

using namespace std;
bool dali(int a[],int n){
    while(n){
    if(a[n]>2)
      return false;
    n--;}
    return true;
}
int fja(int a[],int n){
    if(n==1){
        a[0]=0;
        int x;
        cin>>x;
        return x;
    };
    int b=fja(a,n-1);
     int y;
     cin>>y;
     a[n-1]=a[n-2];
     if(y<b) a[n-1]++;
     return y;
}
int main()
{
    int n,q,i,p,k,b=0,j;
    cin>>n;
    int a[n];
    fja(a,n);
    cin>>q;
    string t[q];
    if(dali(a,n)){
    for( i=0;i<q;i++){
        cin>>p>>k;
        for(j=p;j<k;j++){
           if(a[j+1]<a[j])
              b++;
           if(b==2){
              t[i]="NE";
              break;}}
        if(b<2)
           t[i]="DA";
        b=0;
        
    }}
    else{
    for( i=0;i<q;i++){
        t[i]="NE";
        cin>>p>>k;
        if(a[k-1]-a[p-1]<2) t[i]="DA";
    }}
    for(int i=0;i<q;i++)
    cout<<t[i]<<endl;
    return 0;
}